// Ball.cpp: implementation of the Ball class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "test.h"
#include "Ball.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Ball::Ball(CRect myRect, COLORREF myBrush):GameElement(myRect,myBrush)
{
	// La direction en x est calcule de faon alatoire, par contre
	// Vy est fixe pour partir dans la bonne direction.
    vx = (rand() > (RAND_MAX >> 1))?2:-2;
	vy = -2;
}

Ball::~Ball()
{

}

//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////

// ici un peu special, lorsque la balle entre en collision avec un
// autre objet, on appele la doCollision de Balle avec en param
// l'objet...
int Ball::doCollision( GameElement * ball, int colStatus )
{
    // ... ici pour les effets de la collision
    switch ( colStatus ) {
   	   case COL_TOP :
	   case COL_BOTTOM : vy = -vy;
  		                 break;
	   case COL_RIGHT:
	   case COL_LEFT:    vx = -vx;
		                 break;
	   case COL_CORNER:  vy = -vy;
		                 vx = -vx;
                         break;
	}
	return colStatus;
}


//////////////////////////////////////////////////////////////////////
// Deplace la balle
//////////////////////////////////////////////////////////////////////
void Ball::moveBall()
{
   // deplace la balle d'un pixel dans la bonne direction
   internalRect.OffsetRect(vx,vy);
}

