// Batte.cpp: implementation of the Batte class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Test.h"
#include "Batte.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
Batte::Batte(CRect myRect, COLORREF myBrush, Joueur * myPlayer):GameElement(myRect,myBrush)
{
   min_x = 0; max_x = 200;
   internalPlayer = myPlayer;
}

Batte::~Batte(){ }

//////////////////////////////////////////////////////////////////////
// Deplacements de la batte ( horizontal )
//////////////////////////////////////////////////////////////////////
void Batte::moveBatte(int deplacement)
{
    deplacement = deplacement - internalRect.right;
    if (    ( (internalRect.left  + deplacement) >= min_x )
		 && ( (internalRect.right + deplacement) <= max_x ) ) {
  	   internalRect.OffsetRect(deplacement,0);   
	}
}

void Batte::setMinMaxX(int minx, int maxx)
{
	min_x = minx; max_x = maxx;
}

//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int Batte::doCollision( GameElement * ball, int colStatus )
{
	int ret = ball->doCollision(this,colStatus);
	if ( ret != COL_NONE ) internalPlayer->donnerPoint(-10);
    return ret;
}
