// Batte.cpp: implementation of the Batte class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Arkanoid.h"
#include "Batte.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Batte::Batte(CRect myRect, COLORREF myBrush, Joueur * myPlayer):GameElement(myRect,myBrush),Sound()
{
   min_x = 0;
   max_x = 200;
   internalPlayer = myPlayer;
   setSound("IDR_Batte");
}

Batte::~Batte()
{

}

//////////////////////////////////////////////////////////////////////
// Deplacements de la batte ( horizontal )
//////////////////////////////////////////////////////////////////////

void Batte::moveBatte(int deplacement)
{

    deplacement = deplacement - internalRect.right;

    if (    ( (internalRect.left  + deplacement) >= min_x )
		 && ( (internalRect.right + deplacement) <= max_x ) ) {
  	   internalRect.OffsetRect(deplacement,0);   
	}
}

void Batte::setMinMaxX(int minx, int maxx)
{
	min_x = minx;
	max_x = maxx;
}

//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int Batte::doCollision( GameElement * ball, int colStatus )
{
	// On donne un point lors d'une frappe avec la batte
	internalPlayer->donnerPoint(-10);
	playSound();
    return ball->doCollision(this,colStatus);
}
