// Brique.cpp: implementation of the Brique class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Arkanoid.h"
#include "Brique.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Brique::Brique(CRect myRect, Joueur * myPlayer):GameElement(myRect), Sound()
{
   GameElement::changeBrush(RGB(200,200,30));
   internalPlayer = myPlayer;
   setSound("IDR_Brique");
}

Brique::~Brique()
{

}


//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int Brique::doCollision( GameElement * ball, int colStatus )
{
	if ( !visible ) return COL_NONE;

	// On joue un son
    playSound();

	// La brique est note dtruite
	visible = false;

    // On donne un point lors d'une frappe avec la batte
	internalPlayer->donnerPoint(10);
    return ball->doCollision(this,colStatus);
}

//////////////////////////////////////////////////////////////////////
// ACCES A l'etat
//////////////////////////////////////////////////////////////////////
// revoie true si la brique n'est plus visible (detruite)
bool Brique::getStatus()
{
	return ((visible)?false:true);
}