// BriquePoint.cpp: implementation of the BriquePoint class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Arkanoid.h"
#include "BriquePoint.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

BriquePoint::BriquePoint(CRect myRect, Joueur * myPlayer, GameElement * batte):Brique(myRect,myPlayer)
{
   GameElement::changeBrush(RGB(10,150,200));
   playerBatte = batte;
   points = rand() % 100;
   status = STATUS_INIT;
}

BriquePoint::~BriquePoint()
{

}

//////////////////////////////////////////////////////////////////////
// Fonction de gestion des collisions
//////////////////////////////////////////////////////////////////////
int BriquePoint::doCollision( GameElement * ball, int colStatus )
{
	int ret = COL_NONE;
    if ( status == STATUS_INIT ) {
		status = STATUS_TOUCHE;
		ret = Brique::doCollision(ball,colStatus);
		visible = true;
	}
	return ret;
}

//////////////////////////////////////////////////////////////////////
// Affichage
//////////////////////////////////////////////////////////////////////
BriquePoint::afficheElement(CDC * theGame)
{
	if ( visible ) {
	   if ( status == STATUS_INIT ) {
	      GameElement::afficheElement(theGame);
	   } else {
		  // la brique tombe
		  this->internalRect.OffsetRect(0,1);
		  char str[7];
		  sprintf(str,"-%03d-",points);
  	      theGame->SetTextColor(RGB(10,120,250));
	      theGame->SetBkColor(RGB(0,0,0));
		  theGame->TextOut(getRect().left,getRect().top,str);
		  // teste la sortie ou le contacte avec la batte
		  CRect inter;
		  if ( getRect().bottom > playerBatte->getRect().bottom )
			  visible = false;
		  else if ( inter.IntersectRect(getRect(),playerBatte->getRect()) ) {
   	          setSound("IDR_OptGet");
			  playSound();
			  internalPlayer->donnerPoint(points);
			  visible = false;
		  }
 	   }
	}
}
