// Game.h: interface for the Game class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAME_H__FC1C63E3_56B6_4366_B3FD_3113FDD1BA8B__INCLUDED_)
#define AFX_GAME_H__FC1C63E3_56B6_4366_B3FD_3113FDD1BA8B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ball.h"
#include "Tableau.h"
#include "Joueur.h"
#include "Batte.h"
#include "Brique.h"
#include "BriqueDure.h"

class Game  
{
protected:
	Tableau	   *	gameTab;		// L'objet representant les bords
	Joueur	   *	gamePlayer;		// Le joueur

    Batte      *    gameBatte;		// La batte

	Ball   	   *	gameBall[50];	// Les balles
	int             numBall;		// Balles mises en jeu au total
	int             stillBall;		// Balles restantes en jeu

	Brique     *    gameBrique[50]; //  Les briques
	int             numBrique;

	CWnd       *	gameWin;		// Objet graphique representant le jeu
	CDC        *	gameDc;
	int				winW, winH;		// Taille de la fenetre
	CBitmap			gameBitmap;		// Copie Bitmap pour double buffering
    CDC        *	winDc;

	bool			gameEnd;		// Indique que la partie est finie.	
	bool		    gameWinner;		// Indique que la partie est gagnee.

    CWinThread *	gameThread; 
	int             playerScore;	// memorise le score pour affichage

protected:
    void			createLevel(void);

public:
	int             gameSleep;		// Temps d'attente

	Game(CWnd * _gameWin, Joueur * myPlayer, int mySpeed = 10);
	~Game();
	void paintGame(void);			// Redessine l'ecran
    void setGameEnd(void);          // Demande fin du jeu
	bool getGameEnd(void);			// Interroge etat du jeu
	void startBall(void);			// Lancer une nouvelle balle
    void actionGame(void);			// Faire avancer le jeu
	void moveBatte(CPoint p);		// Deplace la batte
};

#endif // !defined(AFX_GAME_H__FC1C63E3_56B6_4366_B3FD_3113FDD1BA8B__INCLUDED_)
