// Game.h: interface for the Game class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAME_H__FC1C63E3_56B6_4366_B3FD_3113FDD1BA8B__INCLUDED_)
#define AFX_GAME_H__FC1C63E3_56B6_4366_B3FD_3113FDD1BA8B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "Batte.h"
#include "Ball.h"
#include "Tableau.h"
#include "Brique.h"
#include "BriqueDure.h"
#include "BriqueMole.h"
#include "BriquePoint.h"
#include "Joueur.h"

class Game  
{
protected:
	Tableau	   *	gameTab;		// L'objet representant les bords

	Batte	   *	gameBatte;      // La batte

	Ball   	   *	gameBall[50];	// Les balles
	int             numBall;		// Balles mises en jeu au total
	int             stillBall;		// Balles restantes en jeu

	Joueur	   *	gamePlayer;		// Le joueur


	Brique     *    gameBrique[100];// Les briques
	int             numBrique;      // Le nombre de briques

	CWnd       *	gameWin;		// Objet graphique representant le jeu
	CDC        *	gameDc;
	int				winW, winH;		// Taille de la fenetre
	CBitmap			gameBitmap;		// Copie Bitmap pour double buffering
    CDC        *	winDc;

	bool			gameEnd;		// Indique que la partie est finie.	
	bool		    gameWinner;		// Indique que la partie est gagnee.

    CWinThread *	gameThread; 
	int             playerScore;	// memorise le score pour affichage

private:
	// Methode interne de creation du niveau
    void createLevel();

public:
	int             gameSleep;		// Temps d'attente

	Game(CWnd * _gameWin, Joueur * _gamePlayer, int mySpeed = 10);
	~Game();
	void paintGame(void);			// Redessine l'ecran
	void moveBatte(CPoint point);   // Deplacement de la batte
    void setGameEnd(void);          // Demande fin du jeu
	bool getGameEnd(void);			// Interroge etat du jeu
	void startBall(void);			// Lancer une nouvelle balle
    void actionGame(void);			// Faire avancer le jeu
};

#endif // !defined(AFX_GAME_H__FC1C63E3_56B6_4366_B3FD_3113FDD1BA8B__INCLUDED_)
