// GameElement.cpp: implementation of the GameElement class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Arkanoid.h"
#include "GameElement.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
GameElement::GameElement(CRect myRect, COLORREF myBrush)
{
   internalRect  = myRect;
   internalBrush = new CBrush(myBrush);
   visible = true;
}

GameElement::~GameElement()
{
   delete internalBrush;
}

//////////////////////////////////////////////////////////////////////
// SORTIES A L'ECRAN
//////////////////////////////////////////////////////////////////////

GameElement::afficheElement(CDC * theGame)
{
   if (visible)
      theGame->FillRect(internalRect, internalBrush);
}

//////////////////////////////////////////////////////////////////////
// Acces aux donnees
//////////////////////////////////////////////////////////////////////

CRect GameElement::getRect()
{
	return internalRect;
}

void GameElement::changeBrush(COLORREF myBrush)
{
	CBrush * cb = internalBrush;
	internalBrush = new CBrush(myBrush);
	delete cb;
}

//////////////////////////////////////////////////////////////////////
// COLLISION
//////////////////////////////////////////////////////////////////////

int GameElement::performCollision(GameElement * ball)
{
   // On determine ici si les deux objets sont en collision
   // Grace aux methodes des rectangle
   CRect intersec;
   if (intersec.IntersectRect(ball->getRect(),internalRect)) {
	   // il y a une intersection une collision est donc detectee
       // Cherchons sur quel bord...

       int lstatus = 0;
	   int nbord = 0;
	   // Test bord bas :
	   if ( intersec.bottom == internalRect.bottom ) {
		   nbord++;
		   lstatus = COL_BOTTOM;
	   } else {
       // Test bord haut :
		   if ( intersec.top == internalRect.top ) {
			   nbord++;
			   lstatus = COL_TOP;
		   }
	   }

	   // Test bord droit
	   if ( intersec.right == internalRect.right ) {
		   nbord++;
		   lstatus = COL_RIGHT;
	   } else {
	   // Test bord gauche
		   if ( intersec.left == internalRect.left ) {
			   nbord ++;
			   lstatus = COL_LEFT;
		   }
	   }

       // Cas ou la balle est entierement incluse
       if ( nbord == 0 ) return COL_NONE;

	   // Cas des collisions dans les coins
       if ( nbord > 1 ) lstatus = COL_CORNER;
      

       // Effectue le traitement de collision, appel a une methode
	   // virtuelle qui sera definie dans les classes filles...
	   return doCollision(ball,lstatus);
 } else {
	   // Pas de collision
	   return COL_NONE;
   }
}