// GameElement.h: interface for the GameElement class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GAMEELEMENT_H__38EC931C_8D96_4D25_95C5_F670FD12D79E__INCLUDED_)
#define AFX_GAMEELEMENT_H__38EC931C_8D96_4D25_95C5_F670FD12D79E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define COL_NONE	 0
#define COL_BOTTOM   1
#define COL_TOP		 2
#define COL_RIGHT    3
#define COL_LEFT     4
#define COL_CORNER   5
#define COL_LOST     6


class GameElement  
{
protected:
	CRect	  internalRect;
	CBrush  * internalBrush;
	bool      visible;

public:
	
	// Un element est un quadrilatere, on utilise la classe CRect existante pour cela
	// et une couleur de remplissage definie par la classe CBrush
	GameElement(CRect myRect, COLORREF myBrush = RGB(0,0,0));

	// Un element est affich dans un rectangle representant le jeu par la fonction
	// afficheElement
	virtual afficheElement(CDC * theGame);

    // Recuperation des lments de l'objet
    CRect getRect();
 
	// Gestion des collisions entre objet : detection de la collision et appel
	// de la fonction virtuelle doCollision. Retourne COL_NONE ou l'indication
	// de localisation de la colision s'il y a lieu
    int performCollision(GameElement * ball);

	// Effectue le traitement necessaire a la gestion de la collision.
    virtual int doCollision(GameElement * ball, int colStatus) = 0;

	// Permet, apres init de modifier la couleur de la brush
    void changeBrush(COLORREF myBrush);

	virtual ~GameElement();

};

#endif // !defined(AFX_GAMEELEMENT_H__38EC931C_8D96_4D25_95C5_F670FD12D79E__INCLUDED_)
