// Joueur.cpp: implementation of the Joueur class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "test.h"
#include "Joueur.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Joueur::Joueur(CWnd * _scoreWin, CWnd * _balleWin)
{
   scoreWin = _scoreWin;
   balleWin = _balleWin;
   score    = 0;
   balle    = 5;
}

Joueur::~Joueur()
{

}

//////////////////////////////////////////////////////////////////////
// MISE A JOUR SCORE
//////////////////////////////////////////////////////////////////////
void Joueur::donnerPoint(int points)
{
	score += points;
	updateTxt();
}

void Joueur::resetScore()
{
	score = 0;
	balle = 5;
	updateTxt();
}

int Joueur::getScore()
{
	return score;
}

//////////////////////////////////////////////////////////////////////
// Affichage des informations du joueur
//////////////////////////////////////////////////////////////////////
void Joueur::updateTxt()
{
	// Mise a jour score
	char strScore[20];
	sprintf(strScore,"%d",score);
    scoreWin->SetWindowText(strScore);
	scoreWin->UpdateWindow();
    sprintf(strScore,"%d",balle);
    balleWin->SetWindowText(strScore);
    balleWin->UpdateWindow();
}

//////////////////////////////////////////////////////////////////////
// MISE A JOUR BALLES
//////////////////////////////////////////////////////////////////////

// Le joueur utilise une balle
bool Joueur::haveBall()
{
	if ( balle ) {
		balle--;
	    updateTxt();
		return true;
	} 
	return false;
}

// Le joueur gagne des balles
void Joueur::addBall(int num)
{
	balle += num;
	updateTxt();
}